; Universal Lottery by Eugene Accardo
;
; This script, along with the accompanying table and report can be used
; to generate lottery numbers that can probably be used for any State's
; lottery game.
;
; You can get numbers for 1 to 99 games.
;
; You can use this script to get numbers for lottery games that use
; up to 99 numbers to choose from.
;
; You can use this script for lottery games where you have to select
; anywhere from 1 to 12 numbers.
;
; This script is public domain software. Use and distribute freely.
; Direct all inquires to Eugene Accardo, Compuserve I.D. 70413,3127
;


PROC RandN()          ; This procedure creates a randon number.
   x = (INT((HighNum - 1 + 1) * RAND() + 1))
   RETURN x
ENDPROC


PROC COMMAS()                    ; This procedure adds commas to numbers and
   PRIVATE Fld, Last             ; blanks out empty fields in the table.
   Fld = 1
   Last = 1
   EDIT "Lottery"
   WHILE Last < Choose           ; Will not add comma to last number.
      Comma = STRVAL([]) + ", "
      [] = STRVAL(Comma)
      RIGHT
      Last = Last + 1
      Fld = Fld + 1
   ENDWHILE
   RIGHT
   WHILE Fld < 12
      [] = STRVAL(BLANKNUM())    ; Blanks out fields of numbers not used.
      Fld = Fld + 1
      RIGHT
   ENDWHILE
   DO_IT!
ENDPROC


PROC GetNum()                      ; This procedure gets all of the lottery
   Private games, HighNum, Choose  ; numbers for every game and makes sure that
   STYLE ATTRIBUTE 14              ; no two numbers in any game are the same.
   games = ""
   WHILE games = ""                ; Waits for input if user hits [Enter]
      CANVBLOCK()                  ; without entering a number.
      @12, 19
      SETMARGIN 19
      TEXT
 How many lottery GAMES would
 you like to play (from 1-99)?
      ENDTEXT
      @13,50
      ACCEPT "A2"
      PICTURE "#[#]"              ; Only allows entering a 1 or 2 digit number.
      TO games
   ENDWHILE
   games = NumVal(games)          ; Games is the number of games being played.
   HighNum = ""
   WHILE HighNum = ""
      CANVBLOCK()
      @ 12,19
      SETMARGIN 19
      TEXT
 What is the HIGHEST lottery
 number you can choose (from 1-99)?
      ENDTEXT
      @13, 55
      ACCEPT "A2"
      PICTURE "#[#]"
      TO HighNum                  ; HighNum is the highest number you can select.
      IF HighNum = "0"            ; Does not allow a high number of Zero.
         THEN HighNum = ""
      ENDIF
   ENDWHILE
   HighNum = NumVal(HighNum)
   Choose =""
   WHILE Choose = ""
      CANVBLOCK()
      STYLE ATTRIBUTE 14
      @12, 19
      SETMARGIN 19
      TEXT
 How MANY numbers do you have
 to pick (from 1 to 12)?
      ENDTEXT
      @13, 44
      ACCEPT "A2"
      PICTURE "#[#]"
      To Choose                 ; Choose is the number of numbers you have
      If Choose = ""            ; pick in a particular lottery.
         THEN Choose = "0"
      ENDIF
      Choose = NumVal(Choose)
      SWITCH
         CASE Choose = 0:       ; Makes program wait for the user to type a
            Choose = ""         ; number before hitting the Enter key.
         CASE Choose > 12:      ; Checks to see if user tried to pick
            CANVBLOCK()         ; more then 12 numbers.
            STYLE ATTRIBUTE 4
            @11,19
            SETMARGIN 19
            TEXT
 You have tried to select more
 than 12 numbers.

 Please try again.
            ENDTEXT
            SLEEP 5000
            Choose = ""
         CASE Choose > HighNum:   ; Makes sure the number of numbers picked is
            CANVBLOCK()           ; not greater then the highest number that
            STYLE ATTRIBUTE 4     ; be choosen.
            @11,19
            SETMARGIN 19
            TEXT
 The number of numbers you selected is
 greater then the highest number you
 can choose.

 Please try again.
            ENDTEXT
            SLEEP 7000
            Choose = ""
      ENDSWITCH
   ENDWHILE
   CANVBLOCK()
   STYLE ATTRIBUTE 14
   @13, 20
   ??"Please Wait While Numbers Are Processed"
   G = 0
   WHILE G < games             ; Loops until the numbers for every game.
      Number = 2
      ARRAY N[13]              ; Array that numbers are stored in.
      N[2]="0" N[3]="0"  N[4]="0"  N[5]="0"  N[6]="0"  N[7]="0"  N[8]="0"  N[9]="0"  N[10]="0"  N[11]="0" N[12]="0" N[13]="0"
      WHILE Number < Choose + 2  ; Loops until all the numbers for a game are generated.
         PrevNum = 2
         RAndN()                ; Gets random number
         WHILE PrevNum < Choose + 2
            x = STRVAL(x)
            IF x = N[PrevNum]   ; Check to make sure random numbers are not the same
               THEN RandN()     ; If they are the same get another random number.
               PrevNum = 1
            ENDIF
            PrevNum = PrevNum + 1
         ENDWHILE
         N[Number] = x          ; Stores random number in array
         Number = Number + 1
      ENDWHILE
      EDIT "Lottery"
      DOWN
      MOVETO [Lottery #1]
      COPYFROMARRAY N           ; Copies numbers for one game to record in table.
      DO_It!
      COMMAS()                  ; Adds commas to numbers and blanks out numbers not used
      G = G + 1
   ENDWHILE
   Release VARS x, G, PrevNum, Number
   CLEAR
ENDPROC


PROC CANVAS$() ; Procedure to paint canvas with $ sign's
   PAINTCANVAS FILL CHR(36) ATTRIBUTE 2 0, 0, 24, 79
ENDPROC


PROC CANVBLOCK() ; Procedure to paint canvas with message box.
   PAINTCANVAS FILL CHR(219) ATTRIBUTE 0 10, 19, 16, 59
ENDPROC


; The actual script starts here.
Go = "121"                 ; "121" is the code for "y"
CANVAS$()
CANVBLOCK()
STYLE ATTRIBUTE 15
@ 11, 23 ?? "U N I V E R S A L    L O T T E R Y"
@ 13, 39 ?? "by"
@ 14, 33 ?? "Eugene Accardo"
CANVAS ON
SLEEP 2000
STYLE ATTRIBUTE 4
@ 16, 29 ?? "Hit Any Key To Continue"
C = GETCHAR()            ; Accepts any character to continue script.
WHILE Go = "121"         ; Keeps getting numbers if user types "y"
   CANVAS$()
   GetNum()              ; Calls procedure to get lottery numbers.
   CANVAS$()
   SHOWMENU
      "Display"       : "Display Lottery Numbers on Screen",
      "Print"         : "Print Lottery Numbers"
   TO Option
   SWITCH
      CASE Option = "Display":
         {Report} {Output} {Lottery} {1} {Screen}
      CASE Option = "Print":
         {Report} {Output} {Lottery} {1} {Printer}
   ENDSWITCH
   EMPTY "Lottery"              ; empties numbers from table.
   CLEARALL
   CANVAS$()
   CANVBLOCK()
   STYLE ATTRIBUTE 14
   @12, 20
   SETMARGIN 20
   TEXT
 Do You Want To Select More Numbers?

 Hit "Y" for Yes or any other key
 to exit.
   ENDTEXT
   Go = STRVAL(GETCHAR())       ; If user hits "y" the script will get more lottery numbers
ENDWHILE
QUIT
